//Exercise 5: New Keynesian macromodel

var x, pi, i, a, r;
varexo ae;
parameters alph, bet, thet, sig,  rho, phi, phipi, phix, rhoa, lam, kappa, psi;
alph=0.5;
bet = 0.99;
thet = 0.75;
sig = 1;
phi = 1;
rho = -log(bet);
phipi=1.5;
phix=0.125;
rhoa=0.9;
lam=1/thet*(1-thet)*(1-bet*thet);
psi=(1+phi)/(sig*(1-alph)+phi+alph);
kappa=lam*(sig+psi);


model;
x = x(+1) - 1/sig*(i-pi(+1)-r);
pi= bet*pi(+1)+ kappa*x ;
r = rho+sig*psi*(rhoa-1)*a;
i = rho + phipi*pi + phix*x ;
a = rhoa*a(-1)+ae;
end;

initval;
x = 0;
pi= 0;
i = rho;
r = rho;
a=0;
ae=0;
end;

steady;

shocks;
var ae=1;
end;

stoch_simul(periods=10000, irf=12, nofunctions, order=1);
