function [means,vars]=assetsim(mu,sigma,p0,A,n,k)
%Exercise 4
%example of a call [means,vars]=assetsim(0.04,0.3,100,100,20,5000)
dt = 1;%1/n;
%initializations
x=zeros(n,1); %number of assets at each time instant
p(1)=p0;
x(1)=A/p0;
%final wealths with two different investment strategies
wealth1=zeros(k,1);
wealth2=wealth1;
r=mu; %interest rate

pva=annuity(A,r,n-1)+A; 
%present value of annuity paid throughout n periods plus initial period

%loop over simulations
%note: assets are first time bought in period 1
for j = 1:k % perform k random walks
for i = 1:n-1
dX = randn*dt;
dP = p(i)*(mu*dt + sigma*dX);
p(i+1) = p(i)+dP;
x(i+1) = x(i)+A/p(i+1);
end

wealth1(j)= x(end).*p(end);
wealth2(j)=(pva/p(1)).*p(end); %number of assets obtained in period 1 * final price
end
means=[mean(wealth1) mean(wealth2)];
vars=[var(wealth1) var(wealth2)];
